package org.netkernel.client.http.assertion;

import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.representation.IHDSNode;

public class AssertHeader extends StandardAccessorImpl
  {

  public void onSource(INKFRequestContext context) throws Exception
    {
    boolean result;
    IHDSNode responseHeaders;
    IHDSNode testHeaders;

    INKFResponseReadOnly response = context.source("arg:result",INKFResponseReadOnly.class);
    responseHeaders = (IHDSNode)response.getHeader("HTTP_ACCESSOR_RESPONSE_HEADERS_METADATA");
    testHeaders = context.source("arg:condition", IHDSNode.class);

    // Determine if we have a set of headers or just one
    if ("headers".equals(testHeaders.getFirstNode("/").getChildren()[0].getName()))
      {
      IHDSNode[] nodeList = testHeaders.getFirstNode("/").getChildren()[0].getChildren();
      result = true;
      for (int i=0; result && i< nodeList.length;i++)
        {
        String testHeaderName = nodeList[i].getName();
        String testHeaderValue = (String)nodeList[i].getValue();
        IHDSNode responseHeader = responseHeaders.getFirstNode("/" + testHeaderName);

        if (testHeaderValue == null || responseHeader==null)
          {
          result = false;
          }
        else
          {
          result = testHeaderValue.equals(responseHeader.getValue());
          }
        }
      }
    else
      {
      // Single header form
      IHDSNode testHeader = testHeaders.getFirstNode("/").getChildren()[0];
      String testHeaderName = testHeader.getName();
      String testHeaderValue = (String)testHeader.getValue();
      IHDSNode responseHeader = responseHeaders.getFirstNode("/" + testHeaderName);

      if (testHeaderValue == null)
        {
        result = responseHeader != null;
        }
      else
        {
        result = testHeaderValue.equals(responseHeader.getValue());
        }
      }
    context.createResponseFrom(result).setNoCache();
    }
  }


