package org.netkernel.client.http.endpoint;

import org.netkernel.client.http.representation.HttpStateRepresentation;
import org.netkernel.client.http.representation.IHttpClientConfig;
import org.netkernel.layer0.meta.impl.IdentifierArgumentMetaImpl;
import org.netkernel.layer0.meta.impl.SourcedArgumentMetaImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class HttpClientAccessor extends StandardAccessorImpl
{	
	
	public HttpClientAccessor()
	{	declareThreadSafe();
		declareArgument(new IdentifierArgumentMetaImpl("url",null,null));
		declareArgument(new SourcedArgumentMetaImpl("config",null,null,new Class[] {IHttpClientConfig.class}));
		declareArgument(new SourcedArgumentMetaImpl("state",null,null,new Class[] {HttpStateRepresentation.class}));
		declareArgument(new SourcedArgumentMetaImpl("headers",null,null,new Class[] {IHDSNode.class}));
		declareArgument(new SourcedArgumentMetaImpl("nvp",null,null,new Class[] {IHDSNode.class}));
		declareArgument(new SourcedArgumentMetaImpl("body",null,null,new Class[] {IReadableBinaryStreamRepresentation.class}));
		declareSourceRepresentation(IReadableBinaryStreamRepresentation.class);
	}
	
	@Override
	public void onSource(INKFRequestContext aContext) throws Exception
	{	if(aContext.getThisRequest().getIdentifier().startsWith("active:httpAsync"))
		{	HttpClientAsyncAccessorImpl.getInstance().onSource(aContext);
		}
		else
		{	HttpClientAccessorImpl.getInstance().onSource(aContext);
		}
	}
}
