package org.netkernel.client.http.endpoint;

import org.netkernel.client.http.representation.OAuthCredentials;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;

public class OAuthCredentialsTransreptor extends StandardTransreptorImpl
{
	public OAuthCredentialsTransreptor()
	{	this.declareThreadSafe();
		this.declareToRepresentation(OAuthCredentials.class);
	}

	@Override
	public void onTransrept(INKFRequestContext context) throws Exception
	{
		IHDSNode n=context.sourcePrimary(IHDSNode.class);
		n=n.getFirstNode("/oauth");
		String consumerKey=(String)n.getFirstValue("consumerKey");
		String consumerSecret=(String)n.getFirstValue("consumerSecret");
		String accessToken=(String)n.getFirstValue("accessToken");
		String accessTokenSecret=(String)n.getFirstValue("accessTokenSecret");
		OAuthCredentials creds=new OAuthCredentials(consumerKey, consumerSecret, accessToken, accessTokenSecret);
		context.createResponseFrom(creds);
	}
}
