package org.netkernel.client.http.endpoint;

import org.netkernel.client.http.representation.OAuthInitSettings;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;

public class OAuthInitSettingsTransreptor extends StandardTransreptorImpl
{
	public OAuthInitSettingsTransreptor()
	{	this.declareThreadSafe();
		this.declareToRepresentation(OAuthInitSettings.class);
	}

	@Override
	public void onTransrept(INKFRequestContext context) throws Exception
	{
		IHDSNode n=context.sourcePrimary(IHDSNode.class);
		n=n.getFirstNode("/oauth");
		String consumerKey=(String)n.getFirstValue("consumerKey");
		String consumerSecret=(String)n.getFirstValue("consumerSecret");
		String RequestTokenEndpointURL=(String)n.getFirstValue("requestTokenURL");
		String AccessTokenEndpointURL=(String)n.getFirstValue("accessTokenURL");
		String AuthorizeWebSiteURL=(String)n.getFirstValue("authorizeWebSiteURL");
		String CallbackURL=(String)n.getFirstValue("callbackURL");
		OAuthInitSettings settings=new OAuthInitSettings();
		settings.ConsumerKey=consumerKey;
		settings.ConsumerSecret=consumerSecret;
		settings.RequestTokenEndpointURL=RequestTokenEndpointURL;
		settings.AccessTokenEndpointURL=AccessTokenEndpointURL;
		settings.AuthorizeWebSiteURL=AuthorizeWebSiteURL;
		settings.CallbackURL=CallbackURL;
		context.createResponseFrom(settings);
	}
}
